Bug 579155 - libguestfs hangs if qemu doesn't start (in null vmchannel mode)
libguestfs hangs if qemu doesn't start (in null vmchannel mode)
Status: CLOSED UPSTREAM
Product: Virtualization Tools
Classification: Community
Component: libguestfs (Show other bugs)
unspecified
All Linux
low Severity medium
: ---
: ---
Assigned To: Richard W.M. Jones
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-04-02 17:56 EDT by Richard W.M. Jones
Modified: 2010-04-30 19:46 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-04-08 14:32:12 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Richard W.M. Jones 2010-04-02 17:56:17 EDT
Description of problem:

I was running virt-df [the --csv option is not important].  Since one
of the disks was inaccessible, I got an error.  That's not a problem,
but the fact that virt-df *hangs* after this error *is* a problem:

$ virt-df --csv
Virtual Machine,Filesystem,1K-blocks,Used,Available,Use%
"Debian5x64","/dev/debian5x64/home",3555936,1264800,2110504,35.6%
"Debian5x64","/dev/debian5x64/root",329233,200395,111840,60.9%
"Debian5x64","/dev/debian5x64/tmp",309401,10294,283133,3.3%
"Debian5x64","/dev/debian5x64/usr",3539776,1434740,1925224,40.5%
"Debian5x64","/dev/debian5x64/var",1741648,264632,1388544,15.2%
"Debian5x64","/dev/vda1",233335,47272,173615,20.3%
qemu: could not open disk image /dev/vg_trick/RHEL620100329n0x64: Permission denied

(eventually you have to hit ^C)

Version-Release number of selected component (if applicable):

1.0.89

How reproducible:

Always.

Steps to Reproduce:
1. Run virt-df as non-root.
  
Actual results:

If there are any inaccessible disks, virt-df will hang.

Expected results:

Should give an error, but not hang afterwards.

Additional info:

Basically this is a problem that libguestfs does not properly
handle the case where the qemu process dies before connecting
back to the libguestfs socket (in the "null vmchannel" mode).
Comment 1 Richard W.M. Jones 2010-04-08 13:52:10 EDT
A simple reproducer:

export LIBGUESTFS_DEBUG=1
guestfish -- config -dieqemudie "" : run
Comment 3 Fedora Update System 2010-04-09 10:09:58 EDT
libguestfs-1.2.1-1.fc13 has been submitted as an update for Fedora 13.
http://admin.fedoraproject.org/updates/libguestfs-1.2.1-1.fc13
Comment 4 Fedora Update System 2010-04-13 03:43:31 EDT
libguestfs-1.2.2-1.fc13 has been submitted as an update for Fedora 13.
http://admin.fedoraproject.org/updates/libguestfs-1.2.2-1.fc13
Comment 5 Fedora Update System 2010-04-30 19:46:42 EDT
libguestfs-1.2.2-1.fc13 has been pushed to the Fedora 13 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.